unit mfrdemo;

{
Dieses Beispiel zeigt lediglich eine Mglichkeit auf, mit den MFR-Modulen
ber eine Ethernet-Verbindung, unter Verwendung von Standard-Komponenten,
zu kommunizieren. Es wird nicht der Anspruch erhoben, dass die Vorgehensweise
einzigartig oder effizient ist! Das verwendete Protokoll ist UDP (Port 65100).
Achtung!
-- Die IP-Nummer wird nicht berprft.
-- Die Steuerzeichen werden fr die ListBox nicht ausgefiltert
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, NMUDP;


type
  TForm1 = class(TForm)
    mfr: TNMUDP;
    gb1: TGroupBox;
    btnUDPX: TSpeedButton;
    btnUDPI: TSpeedButton;
    btnUDPO: TSpeedButton;
    btnUDPOx: TSpeedButton;
    MFR_IP_Nummer: TEdit;
    lb: TListBox;
    btnClearListBox: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    b7: TCheckBox;
    b6: TCheckBox;
    b5: TCheckBox;
    b4: TCheckBox;
    b3: TCheckBox;
    b2: TCheckBox;
    b1: TCheckBox;
    b0: TCheckBox;
    procedure btnUDPOxClick(Sender: TObject);
    procedure btnUDPXClick(Sender: TObject);
    procedure btnUDPIClick(Sender: TObject);
    procedure btnUDPOClick(Sender: TObject);
    procedure mfrDataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String; Port: Integer);
    procedure FormCreate(Sender: TObject);
    procedure btnClearListBoxClick(Sender: TObject);
  private
    { Private-Deklarationen }
    buf: array[0..255] of char;
    len: integer;
    bits: array[0..7] of ^TCheckBox;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
  begin
  mfr.RemotePort := 65100;
  lb.Clear;
  bits[0] := @b0;
  bits[1] := @b1;
  bits[2] := @b2;
  bits[3] := @b3;
  bits[4] := @b4;
  bits[5] := @b5;
  bits[6] := @b6;
  bits[7] := @b7;
  end;

procedure TForm1.btnUDPOxClick(Sender: TObject);
  var
  i: integer;
  lo_nibble,hi_nibble: byte;
  begin
  mfr.RemoteHost := MFR_IP_Nummer.Text;
  lo_nibble := 64;
  hi_nibble := 64;
  for i:=0 to 3 do
    begin
    if bits[i]^.Checked then lo_nibble := lo_nibble + bits[i]^.Tag;
    end;
  for i:=4 to 7 do
    begin
    if bits[i]^.Checked then hi_nibble := hi_nibble + bits[i]^.Tag;
    end;
  buf[0] := 'O';
  buf[1] := char(hi_nibble);
  buf[2] := char(lo_nibble);
  buf[3] := char(13);
  len := 4;
  lb.Items.Add(format('>%.*s',[len,buf]));
  mfr.SendBuffer(buf,len);
  end;

procedure TForm1.btnUDPXClick(Sender: TObject);
  begin
  mfr.RemoteHost := MFR_IP_Nummer.Text;
  buf[0] := 'X';
  buf[1] := char(13);
  len := 2;
  lb.Items.Add(format('>%.*s',[len,buf]));
  mfr.SendBuffer(buf,len);
  end;

procedure TForm1.btnUDPIClick(Sender: TObject);
  begin
  mfr.RemoteHost := MFR_IP_Nummer.Text;
  buf[0] := 'I';
  buf[1] := char(13);
  len := 2;
  lb.Items.Add(format('>%.*s',[len,buf]));
  mfr.SendBuffer(buf,len);
  end;

procedure TForm1.btnUDPOClick(Sender: TObject);
  begin
  mfr.RemoteHost := MFR_IP_Nummer.Text;
  buf[0] := 'O';
  buf[1] := char(13);
  len := 2;
  lb.Items.Add(format('>%.*s',[len,buf]));
  mfr.SendBuffer(buf,len);
  end;

procedure TForm1.mfrDataReceived(Sender: TComponent; NumberBytes: Integer;
  FromIP: String; Port: Integer);
  begin
  mfr.ReadBuffer(buf,NumberBytes);
  lb.Items.Add(format('<%.*s',[NumberBytes,buf]));
  end;

procedure TForm1.btnClearListBoxClick(Sender: TObject);
  begin
  lb.Clear;
  end;

end.
